
hirom  ; don't change this
header  ; comment out if your rom has no header

org $C21C41  ; location in v1.0 or v1.1
;org $C21C3C  ; location in SFC version
C21C41: JSR hide_check  ; call a new function
;	LDY $3290,X  ; to reverse, uncomment this instruction and comment out all others

org $C259DA  ; location in v1.0 or v1.1
;org $C259C2  ; location in SFC version
C259DA:	LDA $BB  ; targeting byte
C259DC:	AND #$0C  ; isolate "autoselect both parties" and "one party" bits
;REMOVED1:	PHA
	CMP #$04  ; is "both" set and "one" clear?
	BEQ exit  ; if so, exit
C259E2:	BIT #$04  ; if "both" set?
C259E4:	BNE after_targets  ; if so, skip target clearing
C259E6:	LDA $201F  ; encounter type 0-3
REPLACE1: ; three instructions replace two
C259E9:	LSR A  ; Carry set for side, clear for pincer
C259EA:	DEC A
C259EB:	BMI after_targets  ; if neither, skip target clearing
;C259E9:	CMP #$02
;C259EB:	BNE after_pincer
	ROL A
	EOR #$01  ; A = 0 if side, 1 if pincer
	TXY
	CPY #$08  ; check if attacker is a monster
	TAX
	BNE pincer_load  ; if side attack...
	LDA #$0C  ; left side characters, 2 and 3
	XBA
	LDA #$03  ; right side characters, 0 and 1
	ROL A
	EOR #$01  ; invert monster check
	LSR A
	BRA fork  ; if pincer attack...

pincer_load:
C25A01:	LDA $2EAD  ; right side enemies
C25A04:	XBA
C25A05:	LDA $2EAC  ; left side enemies
REPLACE2:  ; one instruction replaces one
C25A08:	INY
;C25A08:	CPX #$08

fork:
C25A09:	BCC check_sides_pincer  ; branch if attacker is in the middle
REPLACE3:  ; one replaces one
C25A0B:	AND $3018,Y  ; is attacker monster on left or character on right?
;C25A0B:	BIT $3019,X
C25A0E:	BEQ remove_pincer_targets  ; if not, clear said front from targets
C25A10:	BRA switch_pincer  ; otherwise, clear opposite front

check_sides_pincer:
REPLACE4:  ; one replaces one
C25A12:	BIT $B8,X  ; are monster on left or characters on right targeted?
;C25A12:	BIT $B9
C25A14:	BEQ after_pincer  ; if not, skip
C25A16:	XBA  ; switch fronts
REPLACE5:  ; one replaces one
C25A17:	BIT $B8,X  ; repeat previous check
;C25A17:	BIT $B9
C25A19:	BEQ after_pincer
C25A1B:	JSR $4B53  ; v1.0 or v1.1
;C25A1B:	JSR $4B3B  ; SFC only
C25A1E:	BCC remove_pincer_targets  ; remove one side at random

switch_pincer:
C25A20:	XBA

remove_pincer_targets:
REPLACE6:  ; three replace one
C25A21:	EOR #$FF
C25A23:	AND $B8,X
C25A25:	STA $B8,X
;C25A21:	TRB $B9

after_pincer:
;REMOVED2:
;	LDA $201F
;	CMP #$03
;	BNE after_targets
;	LDA #$0C
;	XBA
;	LDA #$03
;	CPX #$08
;	BCS check_sides_party
;	BIT $3018,X
;	BEQ remove_side_targets
;	BRA switch_side
;
;check_sides_party:
;	BIT $B8
;	BEQ after_targets
;	XBA
;	BIT $B8
;	BEQ after_targets
;	JSR $4B53  ; v1.0 or v1.1
;	JSR $4B3B  ; SFC only
;	BCC remove_side_targets
;
;switch_side:
;	XBA
;
;remove_side_targets:
;	TRB $B8

after_targets:
;REMOVED3:
;	PLA
;	CMP #$04
;	BEQ exit
C25A27:	LDA $B8
C25A29:	BEQ exit
C25A2B:	LDA $B9
C25A2D:	BEQ exit
C25A2F:	JSR $4B5A  ; v1.0 or v1.1
;C25A2F:	JSR $4B42  ; SFC only
C25A32:	PHX
C25A33:	AND #$01
C25A35:	TAX
C25A36:	STZ $B8,X
C25A38:	PLX
C25A39:	RTS

hide_check:
	PHA
	LDA $3EF9,Y  ; check for Hide status
	ASL A
	ASL A
	ASL A
	PLA
	BCS bmi_trigger  ; only if entity is indeed present do they get a chance to counterattack
	LDY $3290,X  ; alternatively to reverse, comment out the second org and all instructions except this
	RTS

bmi_trigger:
	LDY #$EF  ; triggers a BMI immediately after we return
	RTS

	NOP
	RTS